/*
* Author:          Patrick-Christopher Mattulat
* Co-Author:       Claude Sonnet 4.6 (LLM)
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2023-02-20
* Changed:         2026-06-23
*
* */

#include <gtest/gtest.h>
#include <ls-std/ls-std-core.hpp>
#include <ls-std/ls-std-io.hpp>
#include <string>

using ls::standard::core::IllegalArgumentException;
using ls::standard::io::SectionPairMessageFormatter;
using ls::standard::io::SectionPairRowArgumentEvaluator;
using std::make_shared;
using std::shared_ptr;
using std::string;
using testing::Test;
using testing::TestWithParam;
using testing::Values;

namespace
{
  class SectionPairRowArgumentEvaluatorTest : public Test
  {
    public:

      SectionPairRowArgumentEvaluatorTest() = default;
      ~SectionPairRowArgumentEvaluatorTest() override = default;
  };

  class SectionPairRowArgumentEvaluatorTest_InvalidArgumentTest : public TestWithParam<string>
  {
    public:

      SectionPairRowArgumentEvaluatorTest_InvalidArgumentTest() = default;
      ~SectionPairRowArgumentEvaluatorTest_InvalidArgumentTest() override = default;
  };

  TEST_F(SectionPairRowArgumentEvaluatorTest, getClassName)
  {
    const auto evaluator = make_shared<SectionPairRowArgumentEvaluator>("empty");
    ASSERT_STREQ("SectionPairRowArgumentEvaluator", evaluator->getClassName().c_str());
  }

  TEST_P(SectionPairRowArgumentEvaluatorTest_InvalidArgumentTest, evaluate)
  {
    EXPECT_THROW(
        {
          try
          {
            SectionPairRowArgumentEvaluator(GetParam()).evaluate();
          }
          catch (const IllegalArgumentException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + " thrown - \"" + GetParam() + "\" is not a valid section pair row!";

            ASSERT_STREQ(SectionPairMessageFormatter::getFormattedMessage(expected).c_str(), actual.c_str());
            throw;
          }
        },
        IllegalArgumentException);
  }

  INSTANTIATE_TEST_SUITE_P(InvalidArgumentTest, SectionPairRowArgumentEvaluatorTest_InvalidArgumentTest, Values("heroes:\n  phil", "shapes:\r\n  triangle\r\nsquare"));
}
